; EX1_asm
	bra.s	start
	dc.l	0
	dc.w	$4afb
fname	dc.w	fname_e-fname-2
	dc.b	"EX1 v1.04"
fname_e	ds.b	0
	ds.w	0

	in	win1_ass_pe_keys_pe
	in	win1_ass_pe_qdos_pt
	in	win1_ass_pe_keys_wwork
	in	win1_ass_pe_keys_wstatus
	in	win1_ass_pe_keys_wman
	in	win1_ass_pe_keys_wdef


id	equ	0		window ID
id1	equ	4		directory ID
fnmes	equ	8		-> filename space
wmvec	equ	$C
dirad	equ	$10
hdr	equ	$14		space for header
wkg	equ	$54
*
start	lea	(a6,a4.l),a6	dataspace
	bsr	ope		open a con channel . .
	move.l	a0,id(a6) 	. . keep the ID
	moveq	#iop_pinf,d0
	moveq	#-1,d3
	trap	#3
	tst.l	d0		ptr_gen present? . .
	bne	sui	---->	. . no
	move.l	a1,wmvec(a6)	keep WM vector . .
	beq	sui	---->	. . wasn't there!
	lea	wd0,a3		address of window definition
	movea.l	a1,a2		set WM vector in A2
	move.l	#ww0_0,d1 	size of working definition . .
	bsr	getsp		. . sets ALCHP'd address to A0 . .
	movea.l	a0,a4		. . and to A4
	lea	wst0,a1		Clear the status . .
	movea.l	a1,a0		. . area . .
	moveq	#67,d1		. . and 4 loose items
st1	clr.b	(a0)+
	dbf	d1,st1
	bset	#4,-1(a0) 	set COPY unavailable
	movea.l	id(a6),a0 	Replace the channel ID
	moveq	#0,d1		default size
	jsr	wm_setup(a2)	Set up the working definition
	moveq	#-1,d1		Set the window . .
	jsr	wm_prpos(a2)	. . where the pointer is
	jsr	wm_wdraw(a2)	Draw the contents
	bsr	push		Set a null menu
	bsr	prap		Prints in app window
wrpt	jsr	wm_rptr(a2)	Read the pointer

	beq	no_err
	bra	sui


*

push	movea.l	ww_pappl(a4),a5	address of application . .
	movea.l	(a5),a5		. . window
	clr.l	wwa_part+wwa_clen(a5) no y control block
	clr.l	wwa_ctrl(a5)	no control routine
	clr.l	wwa_nxsc(a5)	no control sections
	clr.l	wwa_draw(a5)	no draw routine
	clr.l	wwa_xspc(a5)
	clr.l	wwa_yspc(a5)
	clr.l	wwa_rowl(a5)
	clr.l	wwa_ncol(a5)	no rows or columns
	move.w	#6,wwa_yoff(a5)	room for arrows
	move.w	#4,wwa_clen+wwa_psac(a5)
	move.w	#7,wwa_clen+wwa_psbc(a5)
	move.w	#4,wwa_clen+wwa_pssc(a5)
	rts

prap	movem.l	a1-3,-(a7)
	moveq	#0,d1		1st app window
	moveq	#-1,d2		no special colours
	jsr	wm_swapp(a2)	set window to app window
	moveq	#0,d1		black paper
	bsr	papert
	bsr	over
	moveq	#7,d1
	bsr	ink
	bsr	cls
	moveq	#2,d1
	moveq	#2,d2
	bsr	at
	lea	te1,a1
	bsr	utm
	moveq	#2,d1
	moveq	#5,d2
	bsr	at
	lea	te2,a1
	bsr	utm
	moveq	#4,d1
	bsr	ink
	moveq	#3,d1
	moveq	#3,d2
	bsr	at
	lea	te3,a1
	bsr	utm
	moveq	#3,d1
	moveq	#6,d2
	bsr	at
	lea	te4,a1
	bsr	utm
	movem.l	(a7)+,a1-3
	rts



papert	moveq	#-1,d3
paper	moveq	#sd_setpa,d0
	bsr	tr3
	moveq	#sd_setst,d0
tr3	trap	#3
	tst.l	d0
tr4	bne	sui	---->
	rts

inkt	moveq	#-1,d3
ink	moveq	#sd_setin,d0
	bra	tr3

att	moveq	#-1,d3
at	moveq	#sd_pos,d0
	bra	tr3

overt	moveq	#-1,d3
over	moveq	#sd_setmd,d0
	bra	tr3

clst	moveq	#-1,d3
cls	moveq	#sd_clear,d0
	bra	tr3

utm	movea.w	ut_mtext,a2
	jsr	(a2)
	bra	tr4

te1	dc.w	te1_e-te1-2
	dc.b	"DISPLAY:"
te1_e	equ	*
te2	dc.w	te2_e-te2-2
	dc.b	"COPY:"
te2_e	equ	*
te3	dc.w	te3_e-te3-2
	dc.b	"Shows files from flp1_"
te3_e	equ	*
te4	dc.w	te4_e-te4-2
	dc.b	"Copies selected files to ram1_"
te4_e	equ	*
	ds.w	0

flp	dc.w	flp_e-flp-2
	dc.b	"flp1_"
flp_e	ds.b	0


con	dc.w	3
	dc.b	'con'

ope	lea	con,a0		To open "con" . .
	moveq	#0,d3
ope1	moveq	#-1,d1		. . for this job
	moveq	#io_open,d0
	trap	#2
	rts

; We come here if we exit from wm_rptr without an error
; This means that D4 is non-zero which in turn means either that there
; was a window event (eg CTRL/F4) or that a loose item action routine
; has set a non-zero value in D4. If there was a window event (and no loose
; item) the appropriate bit will have been set in the event vector in the
; status area.

; If a loose item has a select key equal to that for an event, the event
; will not be detected by WM_RPTR since the loose item's action routine
; will have been called instead. The loose item's action routine can then
; set the event bit in the event vector and force an exit from WM_RPTR by
; setting the event number in D4. In that case the following code would be
; used. On the other hand the loose item's action routine could process the
; event internally without exiting from WM_RPTR.

no_err	movea.l	(a4),a1		status area
	btst	#pt__can,wsp_weve(a1)
	bne	sui		Exit
	btst	#pt__move,wsp_weve(a1)
	beq.s	no_er2
	bsr.s	afun0_0
	bra	wrpt
no_er2	btst	#pt__zzzz,wsp_weve(a1)
	beq	wrpt
	tst.b	ws_litem+3(a1)
	beq	wrpt
	move.l	#ww0_1,d1 	sleep size
	move.l	#ww0_0,d2 	main window size
	bsr	sleep
	bsr	prap
	bsr	push
	bra	wrpt		read pointer again


; Loose item action routines

; MOVE

afun0_0	bsr	move
	move.w	wwl_item(a3),d1	item number
	move.b	#wsi_mkav,ws_litem(a1,d1.w)	  ask for redraw
	moveq	#-1,d3		selective draw
	jsr	wm_ldraw(a2)
	clr.b	ws_litem(a1,d1.w)	available
af1	moveq	#0,d4
	moveq	#0,d0
	rts


; EXIT

afun0_1	moveq	#0,d0
	moveq	#pt__can,d4	ESC
	bset	#pt__can,wsp_weve(a1)
	rts


; DISPLAY

afun0_2	bsr	set_st
	tst.w	d1
	bmi	afun0_1
	movea.l	fnmes(a6),a0	-> file names
	moveq	#36,d2		interval between entries
	movea.l	a1,a5
	movea.l	ww_pappl(a4),a1
	movea.l	(a1),a1		-> app window
	bsr	set_ap
	move.l	a1,dirad(a6)	keep address of objects
	movea.l	a5,a1		replace A1
	movea.l	id(a6),a0 	set ID
	move.w	wwl_item(a3),d1		item number
	move.b	#wsi_mkav,ws_litem(a1,d1.w)	ask for redraw
	moveq	#3,d1
	move.b	#wsi_mkav,ws_litem(a1,d1.w)
	moveq	#-1,d3
	jsr	wm_ldraw(a2)
	clr.b	ws_litem(a1,d1.w)	available
	clr.b	ws_litem(a1,d1.w)	available
	jsr	wm_wrset(a2)
	bne	sui	---->
	jmp	wm_wdraw(a2)


; COPY

afun0_3	bsr	do_cop
	bsr	push
	jsr	wm_wrset(a2)
	bne	sui	---->
	jsr	wm_wdraw(a2)
	move.w	#3,d1		item 3
	move.b	#wsi_mkun,ws_litem(a1,d1.w)
	moveq	#-1,d3		selective redraw
	jsr	wm_ldraw(a2)
	move.b	#wsi_unav,ws_litem(a1,d1.w)	unavailable
	bsr	prap
	bra	af1


; To set the app window

set_st	movem.l	d7/a1-4,-(a7)
	lea	flp,a0
	moveq	#4,d3		open directory
	bsr	ope1
	tst.l	d0
	bne	noflp	---->	no flp1
	move.l	a0,id1(a6)	keep ID
	lea	hdr(a6),a1
	moveq	#-1,d3		timeout
	moveq	#64,d2		buffer
	moveq	#fs_headr,d0
	trap	#3
	tst.l	d0
	bne	noflp	---->	no flp1
	move.l	hdr(a6),d1	directory length
	lsr.l	#4,d1
	mulu	#9,d1		36*number of entries
	bsr	getsp		A0 -> space for filenames
	movea.l	a0,a4		keep space in A4 . .
	move.l	a0,fnmes(a6)	. . and dataspace
	movea.l	id1(a6),a0	ID
	moveq	#64,d2		for 64 bytes (one entry)
	moveq	#0,d7		for number of objects
set_st4	lea	hdr(a6),a1
	moveq	#io_fstrg,d0
	trap	#3
	tst.l	d0
	beq	set_st2
	cmpi.l	#-10,d0
	beq	set_st1		EOF
	bra	noflp	---->
set_st2	tst.l	hdr(a6)		good file? . .
	beq	set_st4		. . no
	move.b	5+hdr(a6),d0	file type
	subq.b	#3,d0
	bhi	set_st4		sub directory
set_st3
	lea	$0E+hdr(a6),a1	-> filename length
	moveq	#8,d0
set_st5	move.l	(a1)+,(a4)+	set name to name space
	dbf	d0,set_st5
	addq.w	#1,d7		advance count
	bra	set_st4


set_st1	moveq	#io_close,d0
	trap	#2
	move.w	d7,d1		count
set_ste	movem.l	(a7)+,d7/a1-4
	rts

noflp	moveq	#-1,d1		mark no flp1
	bra	set_ste



do_cop	move.l	a1,-(a7)
	move.l	#"flp1",wkg+2(a6)
	move.b	#"_",wkg+6(a6)
	movea.l	ww_pappl(a4),a0
	movea.l	(a0),a0		-> app window
	move.w	wwa_nrow(a0),d7	number of items . .
	move.w	d7,d6		. . to D6.W and D7.W
	movea.l	wwa_mstt(a0),a5	-> menu status block
	bra	do_cop1
do_cop2	tst.b	(a5)+
	beq	do_cop1		don't copy this
	move.w	d6,d0
	sub.w	d7,d0
	subq.w	#1,d0		n - count - 1
	mulu	#36,d0
	movea.l	fnmes(a6),a1
	lea	(a1,d0.w),a1	-> filename
	moveq	#5,d1
	add.w	(a1)+,d1
	move.w	d1,wkg(a6)
	moveq	#33,d0
	lea	wkg+7(a6),a0
do_cop3	move.b	(a1)+,(a0)+
	dbf	d0,do_cop3	add filename to "flp1_"
	moveq	#1,d3		OPEN_IN
	lea	wkg(a6),a0
	bsr	ope1
	tst.l	d0
	bne	do_coperr ---->
	lea	hdr(a6),a1
	moveq	#64,d2		header size
	moveq	#-1,d3		timeout
	moveq	#fs_headr,d0
	trap	#3
	movea.l	a0,a3		keep IDin A3
	move.l	hdr(a6),d1	file length
	bsr	getsp		space for file to A0
	exg	a0,a3		ID -> A0 and space address to A3
	move.l	hdr(a6),d2	file length
	moveq	#-1,d3		timeout
	movea.l	a3,a1		space address
	moveq	#fs_load,d0
	trap	#3
	moveq	#io_close,d0
	trap	#2		close file
	move.l	#"ram1",wkg+2(a6)	set filename to "ram1_ . ."
	moveq	#3,d3		open_over
	lea	wkg(a6),a0
	bsr	ope1
	tst.l	d0
	bne	do_copers ---->
	move.l	hdr(a6),d2	file length
	moveq	#-1,d3		timeout
	movea.l	a3,a1
	moveq	#fs_save,d0
	trap	#3
	moveq	#io_close,d0
	trap	#2
	movea.l	a3,a0
	moveq	#mt_rechp,d0
	trap	#1		D1-3,A0-3 clobbered
do_cop1	dbf	d7,do_cop2
	movea.l	(a7)+,a1
	rts

do_copers movea.l	a3,a0
	moveq	#mt_rechp,d0
	trap	#1
do_coperr addq.l	#8,a7
	bra	afun0_1		EXIT

adraw0	jsr	wm_index(a2)
	bne	adr1
	jmp	wm_mdraw(a2)
adr1	rts

ahit0	jmp	wm_mhit(a2)

ahit2_0	moveq	#0,d0
	rts

asmnu0	jmp	wm_smenu(a2)

	in	win1_ass_pe_EX1w_asm


	in	win1_ass_pe_peas_sym_lst
	lib	win1_ass_pe_peas_bin

	in	win1_ass_pe_csprc_sym_lst
	lib	win1_ass_pe_csprc_bin
