; EX2_asm
	bra.s	start
	dc.l	0
	dc.w	$4afb
fname	dc.w	fname_e-fname-2
	dc.b	"EX2 v1.05"
fname_e	ds.b	0
	ds.w	0

	in	win1_ass_pe_keys_pe
	in	win1_ass_pe_qdos_pt
	in	win1_ass_pe_keys_wwork
	in	win1_ass_pe_keys_wstatus
	in	win1_ass_pe_keys_wman
	in	win1_ass_pe_keys_wdef

id	equ	0
id1	equ	4
wmvec	equ	8
secspc	equ	$0C
string	equ	$10	space for string

*
start	lea	(a6,a4.l),a6	dataspace
	bsr	ope		open a con channel . .
	move.l	a0,id(a6) 	. . keep the ID
	moveq	#iop_pinf,d0
	moveq	#-1,d3
	trap	#3
	tst.l	d0		ptr_gen present? . .
	bne	sui	---->	. . no
	move.l	a1,wmvec(a6)	keep WM vector . .
	beq	sui	---->	. . wasn't there!
	lea	wd0,a3		address of window definition
	movea.l	a1,a2		set WM vector in A2
	move.l	#ww0_0,d1 	size of working definition . .
	bsr	getsp		. . sets ALCHP'd address to A0 . .
	movea.l	a0,a4		. . and to A4
	lea	wst0,a1		Clear the status . .
	movea.l	a1,a0		. . area . .
	moveq	#wst0_e-wst0-1,d1	. . and 4 loose items
st1	clr.b	(a0)+
	dbf	d1,st1
	lea	mst0,a0		Clear the . .
	moveq	#mst0_e-mst0-1,d1	. . app . .
st2	clr.b	(a0)+		. . status area
	dbf	d1,st2
	movea.l	id(a6),a0 	Replace the channel ID
	moveq	#0,d1		default size
	jsr	wm_setup(a2)	Set up the working definition
	moveq	#-1,d1		Set the window . .
	jsr	wm_prpos(a2)	. . where the pointer is
	jsr	wm_wdraw(a2)	Draw the contents
wrpt	jsr	wm_rptr(a2)	Read the pointer

	beq	no_err
	bra	sui

no_err	movea.l	(a4),a1		status area
	btst	#pt__can,wsp_weve(a1)
	bne	sui		Exit
	btst	#pt__move,wsp_weve(a1)
	beq.s	no_er2
	bsr.s	afun0_0
	bra.s	wrpt
no_er2	btst	#pt__zzzz,wsp_weve(a1)
	beq.s	wrpt
	move.l	#ww0_1,d1 	sleep size
	move.l	#ww0_0,d2 	main window size
	bsr	sleep
	bsr	print
	bra.s	wrpt		read pointer again


; Loose item action routines

; MOVE

afun0_0	bsr	move
af1	move.w	wwl_item(a3),d1	item number
	move.b	#wsi_mkav,ws_litem(a1,d1.w)	  ask for redraw
	moveq	#-1,d3		selective draw
	jsr	wm_ldraw(a2)
	clr.b	ws_litem(a1,d1.w)	     available
	moveq	#0,d4
	moveq	#0,d0
	rts


; EXIT

afun0_1	moveq	#0,d0
	moveq	#pt__can,d4	ESC
	bset	#pt__can,wsp_weve(a1)
	rts


; PRINT
afun0_3	bsr	print
	bra	af1


; SELECT

afun0_2	movem.l	a0-1/a4,-(a7)
	move.l	#ww1_0,d1 	size for second window
	bsr	getsp		A0 -> space
	move.l	a0,secspc(a6)	save address
	moveq	#wst1_e-wst1-1,d0
	lea	wst1,a1
af02_1	clr.b	(a1)+
	dbf	d0,af02_1 	clear status area
	movea.l	id(a6),a0
	moveq	#0,d1		default size (the only one!)
	lea	wst1,a1		status area
	lea	wd1,a3		second window definition
	movea.l	secspc(a6),a4	space for working definition
	jsr	wm_setup(a2)	set working definition
	moveq	#-1,d1		at cursor
	jsr	wm_pulld(a2)
	move.l	a0,id1(a6)	save the new window ID
	jsr	wm_wdraw(a2)	draw the window
wrpt1	jsr	wm_rptr(a2)	read the pointer in 2nd window
	beq	no_erra		no error at the 2nd window
	bra	sui	---->

no_erra	movea.l	(a4),a1		status area
	btst	#pt__can,wsp_weve(a1)
	beq	no_erra1
	jsr	wm_unset(a2)
	bsr	rechp		throws away A4 wk def
	movea.l	id1(a6),a0
	moveq	#io_close,d0
	trap	#2		close the 2nd window's channel
	movem.l	(a7)+,a0-1/a4	restore A0,A1 & A4
	moveq	#2,d1		item 2
;	 move.w	 ws_citem(a1),d1

	move.b	#wsi_mkav,ws_litem(a1,d1.w)	  ask for redraw
	moveq	#-1,d3		selective draw
	jsr	wm_ldraw(a2)
	clr.b	ws_litem(a1,d1.w)	available

	rts			return to the 1st window

no_erra1	btst	#pt__move,wsp_weve(a1)
	beq.s	no_erra2
	bsr	afun0_0
	bra	wrpt1
no_erra2	moveq	#0,d4		mark no event . .
	moveq	#0,d0		. . and no error
	bra	wrpt1		read pointer again

adraw0	jsr	wm_index(a2)
	bne	adr1
	jmp	wm_mdraw(a2)
adr1	rts


; ENTER or DO in second window's app

ahit0
	cmpi.b	#pt__can,d4
	beq	afun2_1
	tst.w	ws_citem(a1)
	bpl	ah1
	cmpi.b	#pt__do,d4
	beq	dopr		prepare string
ah1	jmp	wm_mhit(a2)

ahit2_0	moveq	#0,d0
	rts

dopr	movem.l	a0-2,-(a7)	keep A0-A2
	moveq	#9,d0
	movea.l	wwa_mstt(a3),a1	pointer to menu status block
;	 movea.l	 a1,a5		 pointer to status area
	moveq	#0,d7		prepare for count
	lea	2+string(a6),a0	place for string
dopr_1	cmpi.b	#$80,(a1)+	is item ON? . .
	bne	dopr_2		. . no
	clr.b	-1(a1)		set to available
	bsr	set_str		sets item to A0 and count to D7
dopr_2	dbf	d0,dopr_1 	count 9 items
	movem.l	(a7)+,a0-2	restore A0-2
	sub.w	#1,d7		ignore final LF
	move.w	d7,string(a6)	set count for printing
	moveq	#0,d3		all items
	jsr	wm_mdraw(a2)	set items to available

afun2_1	bset	#pt__can,wsp_weve(a1)
	moveq	#pt__can,d4	set ESC
	moveq	#0,d0		no error
	rts			exit from reading the pointer

set_str	movea.l	wwa_rowl(a3),a2	-> row list
	moveq	#9,d6
	sub.w	d0,d6		9 - count
	mulu	#wwm_olen,d6
	movea.l	(a2),a2		-> object list
	movea.l	wwm_pobj(a2,d6.l),a2     -> object
	add.w	(a2),d7		increase . .
	addq.w	#1,d7		. . count
	move.w	(a2)+,d1		length of item
	bra	set_str2
set_str1	move.b	(a2)+,(a0)+	add item to string
set_str2	dbf	d1,set_str1
	move.b	#10,(a0)+ 	LF
	rts

afun2_0	equ	afun0_0		MOVE


print	movem.l	d1/a1-3,-(a7)
	moveq	#3,d1		Inf window 3
	moveq	#-1,d2
	jsr	wm_swinf(a2)
	moveq	#0,d1		OVER 0
	bsr	overt
	moveq	#4,d1
	bsr	ink		INK green
	moveq	#0,d1
	bsr	paper		PAPER black
	bsr	cls		clear the window
	lea	string(a6),a1
	bsr	utm		print the string
	movem.l	(a7)+,d1/a1-3
	rts

con	dc.w	3
	dc.b	'con'

ope	lea	con,a0		To open "con" . .
	moveq	#0,d3
ope1	moveq	#-1,d1		. . for this job
	moveq	#io_open,d0
	trap	#2
	rts

papert	moveq	#-1,d3
paper	moveq	#sd_setpa,d0
	bsr	tr3
	moveq	#sd_setst,d0
tr3	trap	#3
	tst.l	d0
tr4	bne	sui	---->
	rts

inkt	moveq	#-1,d3
ink	moveq	#sd_setin,d0
	bra	tr3

att	moveq	#-1,d3
at	moveq	#sd_pos,d0
	bra	tr3

overt	moveq	#-1,d3
over	moveq	#sd_setmd,d0
	bra	tr3

clst	moveq	#-1,d3
cls	moveq	#sd_clear,d0
	bra	tr3

utm	movea.w	ut_mtext,a2
	jsr	(a2)
	bra	tr4



ahit2_1	equ	ahit2_0
ahit2_2	equ	ahit2_0
ahit2_3	equ	ahit2_0
ahit2_4	equ	ahit2_0
ahit2_5	equ	ahit2_0
ahit2_6	equ	ahit2_0
ahit2_7	equ	ahit2_0
ahit2_8	equ	ahit2_0
ahit2_9	equ	ahit2_0


asmnu0	jmp	wm_smenu(a2)

	in win1_ass_pe_EX2w_asm


	in	win1_ass_pe_peas_sym_lst
	lib	win1_ass_pe_peas_bin

	in	win1_ass_pe_csprc_sym_lst
	lib	win1_ass_pe_csprc_bin
